# -*- coding: utf-8 -*-
"""ITS307 -12190075Assignment02.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1QZCCv2bR3oeHVybcZMHiUueLl-Gnu3CS

# ITS307 Data Analytics : Spring Semester 2022
# Assignment 2
# Supervised Learning - Linear Regression

# Table of Contents 
<ol start="0">
<li> Learning Objectives </li>
<li> Importing Libraries </li>
<li> Loading and Cleaning with Pandas</li>
<li> EDA  </li>
<li> Feature Engineering  </li>
<li> Training Model</li>
<li> Predicting</li>
<li> Evaluating Model</li>

</ol>

# Learning Objectives

Second-hand car have huge market base. Many consider to buy a Used Car intsead of buying of new one, as it's is feasible and a better investment.

The dataset shared contains some of the features that determines the second hand car's price in India. Some of the features of are:
- Name: The brand and model of the car
- Location: The location in which the car is being sold or is available for purchase.
- Year: Year or edition of the model
- Kilometers_Driven: The total kilometres driven in the car by the previous owner(s) in KM
- Fuel_Type: The type of fuel used by the car. (Petrol, Diesel, Electric, CNG, LPG)
- Transmission: The type of transmission used by the car. (Automatic / Manual)
- Owner_Type: Whether the owner is first owner or second owner and so on.
- Mileage: The standard mileage offered by the car company in kmpl or km/kg
- Engine: The displacement volume of the engine in CC.
- Power:
- Seat: Number of the seat of car
- New_Price: Price of the car when its new/first hand
- Price (Target) : Price of the used car

# 1. Loading Libraries
"""

# Commented out IPython magic to ensure Python compatibility.
#Import libraries
import matplotlib.pyplot as plt
import pandas as pd
import seaborn as sns
# %matplotlib inline
import numpy as np

from sklearn.linear_model import LinearRegression
from sklearn.datasets import load_boston

"""# 2. Loading and Cleaning with Pandas"""

# Loading files
train = pd.read_csv('train-data.csv')
test = pd.read_csv('test-data.csv')

train.head()

test.head()

train = train.drop(['Unnamed: 0'],axis=1)
train.head()

test = test.drop(['Unnamed: 0'],axis=1)
test.head()

# rows and columns
train.shape

# rows and columns
test.shape

# null values
train.isnull().sum()

#datatype
train.dtypes

# Dropping the New Price column because it contains 5195 null values and has a zero signicant.
train.drop(['New_Price'],axis = 1, inplace = True)
print(train.info())
train.shape

# checking for the null values
train.isnull().sum()

# Dropping null values
train.dropna(inplace = True, axis = 0)
train.shape

train.head(10)

#Finding unique values in the columns Engine, Mileage, and Power
print(train['Engine'].unique())
print(train['Mileage'].unique())
print(train['Power'].unique())

# Removing the string from column Engine, Mileage and Power
train['Mileage'] = train['Mileage'].str.replace('km/kg', ' ')
train['Mileage'] = train['Mileage'].str.replace('kmpl', ' ')
train["Engine"] = train["Engine"].str.replace('CC',' ')
train['Power'] = train['Power'].str.replace('bhp', ' ')
train.head(5)

train.info()

# Objects in the Engine, Mileage, and Power columns are being converted to floats.
train["Engine"] = train["Engine"].astype(float)
train["Mileage"] = train["Mileage"].astype(float)

# Due to the fact that the Power column is an object.It contains float and null values, both of which are difficult to convert to float. As a result, I changed the null value to 0.
train['Power'] = train['Power'].str.replace('null','0')

# Changing data types
train["Power"] = train["Power"].astype(float)
train.info()

# Replacing 0 values as nan
train['Power'] = train['Power'].replace(0, np.nan)
train.isnull().sum()

#By checking, then i have drop the null values
train.dropna(inplace = True)
print(train.shape)
train.isnull().sum()

train.info()

"""# 3.  EDA and Visualization

To begin, I categorized each feature as categorical, numerical, continuous, or discrete and then clasified
"""

# classify the non-numerical characteristics.
category_features = [x for x in train.columns if train[x].dtype == 'O']

# Classify the numerical features
numerical_features = [x for x in train.columns if train[x].dtype != 'O']

# Classify the discrete features
discrete_features = [x for x in numerical_features
                     if len(train[x].unique()) < 25]

# Classify the continuous features
continuous_features = [x for x in numerical_features
                      if x not in discrete_features]

# Check
print(f"Categorical features: {category_features}\nNumerical features: {numerical_features}\
\nDiscrete features: {discrete_features}\nContinuous features: {continuous_features}")

# Creating a list of categorical columns to check for data imbalances and plot them
col_category = ['Year', 'Fuel_Type','Transmission','Owner_Type']

k=0
plt.figure(figsize=(15,25))
for col in col_category:    
    k=k+1
    plt.subplot(4, 3,k)    
    train[col].value_counts().plot(kind='bar');
    plt.title(col)

# Finding correlation of columns with Price
correlation = train.corr()['Price']
correlation

#Plotting correlation heatmap
sns.set(rc={'figure.figsize':(12,8)})
sns.heatmap(abs(train.corr() >= 0.7),annot=True);

#To plot the scatter graph for power and price
train.plot(x = 'Power', y = 'Price')

#To plot the scatter graph for engine and price
train.plot(x = 'Engine', y = 'Price', kind = 'scatter')

# To plot the scatter graph for year and price
train.plot.line(x = 'Year', y = 'Price')

"""# 4. Feature Engineering """

# Checking categorical data distribution in train dataframe
print(train.Fuel_Type.value_counts())
print(train.Transmission.value_counts())
print(train.Owner_Type.value_counts())
print(train.Seats.value_counts())

# encoding for Categorical data
train.replace({'Fuel_Type':{'Diesel': 0, 'Petrol': 1, 'CNG': 2, 'LPG':3}}, inplace = True)
train.replace({'Transmission':{'Automatic': 0, 'Manual': 1}}, inplace = True)
train.replace({'Owner_Type':{'First': 0, 'Second': 1, 'Third': 2, 'Fourth & Above':3}}, inplace = True)
train.head(5)

# To check the outliners, i have created columns 
columns = ['Mileage', 'Kilometers_Driven',  'Engine']

# Mileage outlier
sns.boxplot(train[columns[0]]);

# Kilometer_Driven outlier
sns.boxplot(train[columns[1]]);

# Engine outlier
sns.boxplot(train[columns[2]]);

# Outliers can be found in the 'Mileage', 'Kilometer Driven' and 'Engine' columns, as can be seen. We'll use the Inter Quantile Range(IQR) method to get rid of these outliers.
def find_outliers_limit(train,column):
    print(column)
    print('-'*50)
# To remove the outliers
    Q1, Q3 = np.percentile(train[column], 25), np.percentile(train[column], 75)
    IQR = Q3 - Q1
    print('Percentiles: 25th=%.3f, 75th=%.3f, IQR=%.3f' % (Q1, Q3, IQR))

# To calculate the outlier cutoff, we have:
    # upperlimit = Q3 + (IQR * 1.5)cut_off
    # lowerlimit = Q1 - (IQR * 1.5)cut_off
    cut_off = IQR * 1.5
    lower, upper = Q1 - cut_off, Q3 + cut_off
    print('Lower:',lower,' Upper:',upper)
    return lower,upper

def remove_outlier(train,column,upper,lower):
  # identify outliers
  outliers = ["x for x in train[column] if x  upper"]
  print('Identified outliers: %d' % len(outliers))
  # remove outliers
  outliers_removed = [x for x in train[column] if x >= lower and x <= upper]
  print('Non-outlier observations: %d' % len(outliers_removed))
  final= np.where(train[column]>upper,upper,np.where(train[column]<lower,lower,train[column]))
  return final
outlier_cols=['Mileage','Kilometers_Driven' , 'Engine']
for column in outlier_cols:
  lower,upper=find_outliers_limit(train,column)
  train[column] = remove_outlier(train,column,upper,lower)

# After removing outliers
plt.figure(figsize=(20,10))
train[outlier_cols].boxplot()

#To Find out the Target variable price (y)
y = train['Price']
y.head(5)

#Using the Get dummies function to convert categorical data to quantitative data
x = train.drop(['Price','Name'],axis = 1)
x = pd.get_dummies(x,columns=['Location','Seats'])
x.head(5)

x.info()

"""# 5. Training Model"""

#For Training and Testing, first we need to import it libaries
from sklearn.model_selection import train_test_split

#For training and testing, we need to split the data
x_train, x_test, y_train, y_test = train_test_split(x, y, test_size = 0.20, random_state = 10)

#To check the rows and columns of all splitted data
print("x_train",x_train.shape,"x_test",x_test.shape,"y_train",y_train.shape,"y_test",y_test.shape)

x_train.head(5)

x_test.head(5)

#Import libraries
from sklearn.preprocessing import StandardScaler
from sklearn.linear_model import LogisticRegression
from sklearn.metrics import accuracy_score, confusion_matrix, classification_report, plot_confusion_matrix

#For feature preprocessing, use a standard scaler
scaler = StandardScaler()
scale = scaler.fit(x_train)
x_train = scale.transform(x_train)
x_test = scale.transform(x_test)

# To create a model
y_train = y_train.astype(int)
y_test = y_test.astype(int)
model = LogisticRegression()
print(model.fit(x_train,y_train))

"""# 6. Prediction"""

#To score our model, make a prediction against the test set.
y_prediction = model.predict(x_test)
y_prediction

from sklearn.metrics import mean_squared_error
from sklearn.metrics import mean_absolute_error

#To see the errors
print('Those are the given errors:\n')
print('R-squared training data: ', model.score(x_train, y_train))
print('R-squared test data: ', model.score(x_test, y_test))
print('MSE: ', mean_squared_error(y_test, y_prediction))
print('MAE: ', mean_absolute_error(y_test, y_prediction))
print('RMSE: ', np.sqrt(mean_squared_error(y_test, y_prediction)))

"""# 7. Evaluating your Model"""

# To check the accuracy
score = accuracy_score(y_test, y_prediction)
score

#To creat the confusion matrix
confusion_matrix(y_test, y_prediction)

matrix = classification_report(y_test, y_prediction)
print ("-------------------Classified Report----------------\n")
print(matrix)

from sklearn.metrics import ConfusionMatrixDisplay

ConfusionMatrix = confusion_matrix(y_test, y_prediction, labels=model.classes_)
display = ConfusionMatrixDisplay(confusion_matrix=ConfusionMatrix, display_labels = model.classes_)
fig, ax = plt.subplots(figsize=(25,25))
display.plot(ax=ax)
plt.show()

# Error terms
error = [i for i in range(len(y_prediction))]
fig = plt.figure()
plt.plot(error,y_test-y_prediction, color="green", linewidth=2.5, linestyle="-")
# Plot title 
fig.suptitle('Graph Representation of Error Terms')  
# X-label                 
plt.xlabel('Index')         
# Y-label                   
plt.ylabel('ytest and yprediction')               
plt.show()

plt.scatter(y_test,y_prediction)

"""Scatter plots are used to visualize relationships between variables, with dots representing the relationship. The points are nearly aligned in a line here."""

sns.displot(y_prediction)

"""# SUBMISSION DATE: 2nd April 2022"""